﻿'    License: Microsoft Public License (Ms-PL) 
Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.IO
Imports Lucene.Net.Store

    ''' <summary>
    ''' Stream wrapper around IndexInput
    ''' </summary>
    Public Class StreamInput
    Inherits Stream

    Private _Input As IndexInput
    Public Property Input() As IndexInput
        Get
            Return _Input
        End Get
        Set(ByVal value As IndexInput)
            _Input = value
        End Set
    End Property

    Public Sub New(ByVal input As IndexInput)
        Me.Input = input
    End Sub

    Public Overrides ReadOnly Property CanRead() As Boolean
        Get
            Return True
        End Get
    End Property
    Public Overrides ReadOnly Property CanSeek() As Boolean
        Get
            Return True

        End Get
    End Property
    Public Overrides ReadOnly Property CanWrite() As Boolean
        Get
            Return False
        End Get
    End Property
    Public Overrides Sub Flush()
    End Sub
    Public Overrides ReadOnly Property Length() As Long
        Get
            Return Input.Length()
        End Get
    End Property

    Public Overrides Property Position() As Long
        Get
            Return Input.GetFilePointer()
        End Get
        Set(ByVal value As Long)
            Input.Seek(value)
        End Set
    End Property

    Public Overrides Function Read(ByVal buffer() As Byte, ByVal offset As Integer, ByVal count As Integer) As Integer
        Dim pos As Long = Input.GetFilePointer()
        Try
            Dim len As Long = Input.Length()
            If count > (len - pos) Then
                count = CInt(Fix(len - pos))
            End If
            Input.ReadBytes(buffer, offset, count)
        Catch e1 As Exception
        End Try
        Return CInt(Fix(Input.GetFilePointer() - pos))
    End Function

    Public Overrides Function Seek(ByVal offset As Long, ByVal origin As SeekOrigin) As Long
        Select Case origin
            Case SeekOrigin.Begin
                Input.Seek(offset)
            Case SeekOrigin.Current
                Input.Seek(Input.GetFilePointer() + offset)
            Case SeekOrigin.End
                Throw New System.NotImplementedException()
        End Select
        Return Input.GetFilePointer()
    End Function

    Public Overrides Sub SetLength(ByVal value As Long)
        Throw New System.NotImplementedException()
    End Sub

    Public Overrides Sub Write(ByVal buffer() As Byte, ByVal offset As Integer, ByVal count As Integer)
        Throw New System.NotImplementedException()
    End Sub

    Public Overrides Sub Close()
        Input.Close()
        MyBase.Close()
    End Sub
End Class