﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.ServiceModel.Web
Imports System.Text

'Imports Lucene.Net.Index
'Imports Lucene.Net.Store
'namespace collision with DocumentFormat.OpenXml so I gave it an alias
'Imports LuceneDocs = Lucene.Net.Documents
'Imports Lucene.Net.Analysis.Standard
Imports Lucene.Net.Store.Azure
Imports Lucene.Net.Search
Imports Lucene.Net.Documents
Imports Lucene.Net.QueryParsers
Imports Lucene.Net.Analysis.Standard

Imports Microsoft.WindowsAzure.StorageClient
Imports Microsoft.WindowsAzure
Imports Microsoft.WindowsAzure.ServiceRuntime

' NOTE: You can use the "Rename" command on the context menu to change the class name "Service1" in code, svc and config file together.
Public Class Service1
    Implements ISearchService

    Public Sub New()
    End Sub

    Public Function Search(ByVal SearchTerms As String) As List(Of SearchResult) Implements ISearchService.Search
        Dim retval As New List(Of SearchResult)()

        CloudStorageAccount.SetConfigurationSettingPublisher(Sub(configName, configSettingPublisher)
                                                                 Dim configValue As String = RoleEnvironment.GetConfigurationSettingValue(configName)
                                                                 configSettingPublisher(configValue)
                                                             End Sub)


        Dim storageAccount As CloudStorageAccount = CloudStorageAccount.FromConfigurationSetting("StorageAccount")
        Dim BlobClient As CloudBlobClient = storageAccount.CreateCloudBlobClient()

        'open index
        Dim azureDirectory As New AzureDirectory(storageAccount, "cloudindex")
        Dim searcher As New IndexSearcher(azureDirectory)

        'for the sample I'm just searching the body
        Dim parser As New QueryParser("Body", New StandardAnalyzer())
        Dim query As Query = parser.Parse("Body:(" & SearchTerms & ")")
        Dim hits As Hits = searcher.Search(query)

        For idxResults = 0 To hits.Length() - 1
            Dim newSearchResult As New SearchResult()
            Dim doc As Document = hits.Doc(idxResults)


            newSearchResult.Title = doc.GetField("Title").StringValue()
            newSearchResult.Uri = doc.GetField("Uri").StringValue()

            retval.Add(newSearchResult)
        Next idxResults

        Return retval
    End Function

    Public Function GetDataUsingDataContract(ByVal composite As CompositeType) As CompositeType Implements ISearchService.GetDataUsingDataContract
        If composite Is Nothing Then
            Throw New ArgumentNullException("composite")
        End If
        If composite.BoolValue Then
            composite.StringValue &= "Suffix"
        End If
        Return composite
    End Function

End Class
